/*Copyright (C) 2021, Mark Robillard Jr
 *
 * This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

#include <iostream>
#include <fstream>
#include <string>
#include <time.h>


class RecordSave { 
  public: 
    std::string save(int humanpoints, int cpupoints, std::string humanteam, std::string cputeam);
};


std::string RecordSave::save(int humanpoints, int cpupoints, std::string humanteam, std::string cputeam) {
  //uses tm struct to display the time for record keeping
  time_t rawtime;
  struct tm * timeinfo;
  time( & rawtime);
  timeinfo = localtime( & rawtime);
  std::string score = asctime(timeinfo);
  score.append("************************\n" + humanteam +": " + std::to_string(humanpoints) + "\n"
  + cputeam + ": " + std::to_string(cpupoints) +"\n************************\n");
  std::ofstream outfile;
  outfile.open("FreeBatterRecords.txt", std::ios_base::app);
  outfile << score;
  outfile.close();
  return score;
}
